<mat-card>
    <mat-card-title fxLayout="row" fxLayoutAlign="start center">
        <div fxFlex="auto" fxLayoutAlign="center center">
            <mat-icon *ngIf="missingPercentage"
                #tooltip="matTooltip"
                [matTooltip]="'NOT_A_WHOLE' | translate">
                warning
            </mat-icon>
        <app-in-place-input
                [value]="bucket.name"
                [required]="true"
                (onSubmit)="changeBucketName($event)">
        </app-in-place-input>
        {{' @ '}}{{bucketValuation | number: '1.2-2'}}{{' ' + mainCurrency?.name}}
        </div>
        <button mat-icon-button
            (click)="bucketTrashClicked()">
            <mat-icon>delete</mat-icon>
        </button>
        <button mat-icon-button
            (click)="onAddAllocation()">
            <mat-icon>add</mat-icon>
        </button>
    </mat-card-title>
    <mat-card-content fxLayout="column" fxLayoutAlign="start center">
        <div *ngIf="allocationFormVisible">
            <form [formGroup]="allocationForm" fxFlex fxLayout="row" fxLayoutAlign="start center"
                (keyup)="onFormKeyUp($event)">
                <mat-form-field appearance="fill" class="mr-1">
                    <mat-label>{{ 'TAG' | translate }}</mat-label>
                    <input matInput autocomplete="off" formControlName="tag"
                        [class.error]="!isTagValid()" />
                </mat-form-field>
                <mat-form-field appearance="fill" class="mr-1">
                    <mat-label>{{ 'Percentage' | translate }}</mat-label>
                    <input matInput autocomplete="off" formControlName="percentage"
                        (change)="onNewPercentageChange($event)"
                        (keyup)="onNewPercentageChange($event)"
                        [class.error]="!isPercentageValid()"
                        type="number" />
                </mat-form-field>
                <div>
                    <button mat-raised-button class="mr-1"
                        (click)="onAllocationFormSubmit()"
                        [disabled]="!isTagValid() || !isPercentageValid()"
                        type="submit">
                        {{ 'ADD' | translate }}
                    </button>
                    <button mat-icon-button
                        (click)="onFormTrash()"
                        type="reset">
                        <mat-icon>delete</mat-icon>
                    </button>
                </div>
            </form>
        </div>
        <mat-accordion multi style="width: 100%;" class="mt-2">
            <mat-expansion-panel *ngFor="let allocation of allocations"
                class="border-b border-gray-400"
                [ngClass]="{'outdated': allocation.anythingOutdated }">
                <mat-expansion-panel-header>
                    <mat-panel-title fxLayout="row" fxLayoutAlign="start center">
                        <div fxFlex="0 0 20%">
                            <button mat-icon-button
                            (click)="allocationTrashClicked(allocation)">
                                <mat-icon>delete</mat-icon>
                            </button>
                            {{allocation.tag}}
                        </div>
                        <div fxFlex="0 0 20%" fxLayoutAlign="start center">
                            <app-in-place-input
                                [value]="allocation.percentage"
                                [required]="true"
                                format="1.2-2"
                                (onSubmit)="changeBucketAllocation(allocation,
                                $event)"
                                (onChange)="allocationPercenntageChanged(allocation,
                                $event)">
                            </app-in-place-input>
                            %
                        </div>
                        <div fxFlex="1 0 33%" fxLayout="row">
                            <div fxFlex="auto">
                                {{((100 * allocation.totalValuation / bucketValuation) | number: '1.2-2') + ' %'}}
                            </div>
                            <div>
                                @ {{allocation.totalValuation | number: '1.2-2'}}{{' ' + mainCurrency?.name}}
                            </div>
                        </div>
                    </mat-panel-title>
                </mat-expansion-panel-header>
                <div *ngFor="let position of allocation.relevantPositions" class="border-t border-gray-400" fxLayout="row" fxLayoutAlign="start center">
                    <div fxFlex="0 0 20%" fxLayout="row" fxLayoutAlign="start center">
                        {{position.name}}
                        <mat-icon color="primary" *ngIf="position.value.outdated"
                            #tooltip="matTooltip"
                            [matTooltip]="'OUTDATED_VALUE_OR_INCOMPATIBLE_EXCHANGE_RATE' | translate">elderly</mat-icon>
                    </div>
                    <div fxFlex="0 0 20%"></div>
                    <div fxFlex="1 0 33%" fxLayout="row">
                        <div fxFlex="auto">
                            {{((100 * position.value.value / allocation.totalValuation) | number: '1.2-2') + ' %'}}
                        </div>
                        <div>
                            {{position.value.value | number: '1.2-2'}}{{' ' + mainCurrency?.name}}
                        </div>
                    </div>
                </div>
            </mat-expansion-panel>
        </mat-accordion>
        <div fxLayout="row" class="mt-4">
            <apx-chart *ngIf="showExpectedChart"
            [series]="expectedPieOptions.series"
            [chart]="expectedPieOptions.chart"
            [labels]="expectedPieOptions.labels"
            [dataLabels]="expectedPieOptions.dataLabels"
            [legend]="expectedPieOptions.legend"
            [title]="expectedPieOptions.title"
            [responsive]="expectedPieOptions.responsive"></apx-chart>
            <apx-chart *ngIf="showCurrentChart"
            [series]="currentDonutOptions.series"
            [chart]="currentDonutOptions.chart"
            [labels]="currentDonutOptions.labels"
            [dataLabels]="currentDonutOptions.dataLabels"
            [legend]="currentDonutOptions.legend"
            [title]="currentDonutOptions.title"
            [responsive]="currentDonutOptions.responsive"></apx-chart>
        </div>
    </mat-card-content>
</mat-card>